//
//  Timer+Add.swift
//  SwiftProject
//
//  Created by soldoros on 2024/1/10.
//

import Foundation
import UIKit

extension Timer{
    
    //时间戳转日期 yyyy-MM-dd
    class func dateWithStamp1(stamp:String)->String{
        
        let format = "yyyy-MM-dd"
        return Timer.dateFromTimeStamp(stamp: stamp, format: format)
    }
    
    //时间戳转日期 yyyy-MM-dd HH:mm:ss
    class func dateWithStamp(stamp:String)->String{
        
        let format = "yyyy-MM-dd HH:mm:ss"
        return Timer.dateFromTimeStamp(stamp: stamp, format: format)
    }
    
    
    //时间戳转日期 格式自己定义
    class func dateFromTimeStamp(stamp:String, format:String)-> String{
        
        var timeInterval:TimeInterval = Double(stamp)!
        if(stamp.count == 13){
            timeInterval = timeInterval / 1000
        }
        let date = NSDate(timeIntervalSince1970: timeInterval)
        
        let dformatter = DateFormatter()
        dformatter.dateFormat = format
        
        return dformatter.string(from: date as Date)
    }
    
    //MARK: -根据后台时间戳返回几分钟前，几小时前，几天前
    class func updateTimeToCurrennTime(timeStamp: Double) -> String {
        //获取当前的时间戳
        let currentTime = Date().timeIntervalSince1970
        print(currentTime,   timeStamp, "sdsss")
        //时间戳为毫秒级要 ／ 1000， 秒就不用除1000，参数带没带000
        let timeSta:TimeInterval = TimeInterval(timeStamp / 1000)
        //时间差
        let reduceTime : TimeInterval = currentTime - timeSta
        
        //时间差小于60秒
        if reduceTime < 60 {
            return "刚刚"
        }
        //时间差大于一分钟小于60分钟内
        let mins = Int(reduceTime / 60)
        if mins < 60 {
            return "\(mins)分钟前"
        }
        let hours = Int(reduceTime / 3600)
        if hours < 24 {
            return "\(hours)小时前"
        }
        let days = Int(reduceTime / 3600 / 24)
        if days < 30 {
            return "\(days)天前"
        }
        //不满足上述条件---或者是未来日期-----直接返回日期
        let date = NSDate(timeIntervalSince1970: timeSta)
        let dfmatter = DateFormatter()
        //yyyy-MM-dd HH:mm:ss
        dfmatter.dateFormat="yyyy年MM月dd日 HH:mm:ss"
        return dfmatter.string(from: date as Date)
    }
}

